using System;
using System.Collections.Generic;
using Library;
using LitJson;
using System.Linq;
using System.Data;
using System.Threading;
using MySystem.PxcModels;

namespace MySystem
{
    public class StatService
    {
        public readonly static StatService Instance = new StatService();
        private StatService()
        { }






        // 统计交易额V2
        public void Start()
        {
            Thread th = new Thread(StartDo);
            th.IsBackground = true;
            th.Start();
        }
        public void StartDo()
        {
            while (true)
            {
                if(DateTime.Now.Hour >= 3)
                {
                    StatTradeAmountV2();
                }
                Thread.Sleep(30000);
            }
        }
        public void StatTradeAmountV2()
        {
            OtherMySqlConn.connstr = Library.ConfigurationManager.AppSettings["SqlConnStr"].ToString();
            function.WriteLog(DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss.fff"), "统计商户和创客交易额日志");
            WebCMSEntities db = new WebCMSEntities();
            using (var tran = db.Database.BeginTransaction())
            {
                try
                {
                    string startId = function.ReadInstance("/ConsumerOrders/Id.txt");
                    DataTable idsDt = OtherMySqlConn.dtable("select Id from ConsumerOrders where Id>=" + startId + " and QueryCount=0 order by Id limit 50");
                    if(idsDt.Rows.Count > 0)
                    {
                        string ids = "";
                        foreach (DataRow idsDr in idsDt.Rows)
                        {
                            ids += idsDr["Id"].ToString() + ",";
                            startId = idsDr["Id"].ToString();
                        }
                        DataTable selfDt = OtherMySqlConn.dtable("select UserId,MerchantId,PayMode,DATE_FORMAT(CreateDate,'%Y%m%d'),sum(PayMoney),count(Id) from ConsumerOrders where Id in (" + ids.TrimEnd(',') + ") group by UserId,MerchantId,PayMode,DATE_FORMAT(CreateDate,'%Y%m%d')");
                        if (selfDt.Rows.Count > 0)
                        {
                            function.WriteLog("统计人数:" + selfDt.Rows.Count + "\n\n", "统计商户和创客交易额日志");
                            foreach (DataRow selfDr in selfDt.Rows)
                            {
                                int UserId = int.Parse(selfDr["UserId"].ToString());
                                Users user = db.Users.FirstOrDefault(m => m.Id == UserId) ?? new Users();
                                string ParentNav = user.ParentNav;
                                int MerchantId = int.Parse(selfDr["MerchantId"].ToString());
                                int PayMode = int.Parse(selfDr["PayMode"].ToString());
                                string TradeDate = selfDr[3].ToString();
                                decimal TradeAmount = decimal.Parse(selfDr[4].ToString());
                                int TradeCount = int.Parse(selfDr[5].ToString());
                                string TradeMonth = TradeDate.Substring(0, 6);

                                //创客交易额
                                UserAmountSummary selfStat = db.UserAmountSummary.FirstOrDefault(m => m.UserId == UserId && m.TradeMonth == TradeMonth && m.TradeDate == TradeDate && m.PayMode == PayMode && m.SeoTitle == "self");
                                if (selfStat == null)
                                {
                                    selfStat = db.UserAmountSummary.Add(new UserAmountSummary()
                                    {
                                        UserId = UserId,
                                        TradeMonth = TradeMonth,
                                        TradeDate = TradeDate,
                                        PayMode = PayMode,
                                        SeoTitle = "self",
                                    }).Entity;
                                    db.SaveChanges();
                                }
                                selfStat.TotalAmount += TradeAmount;
                                selfStat.QueryCount += TradeCount;
                                ParentNav += "," + UserId + ",";
                                if (!string.IsNullOrEmpty(ParentNav))
                                {
                                    string[] ParentNavList = ParentNav.Trim(',').Replace(",,", ",").Split(',');
                                    foreach (string NavUserIdString in ParentNavList)
                                    {
                                        int NavUserId = int.Parse(NavUserIdString);
                                        UserAmountSummary teamStat = db.UserAmountSummary.FirstOrDefault(m => m.UserId == UserId && m.TradeMonth == TradeMonth && m.TradeDate == TradeDate && m.PayMode == PayMode && m.SeoTitle == "team");
                                        if (teamStat == null)
                                        {
                                            teamStat = db.UserAmountSummary.Add(new UserAmountSummary()
                                            {
                                                UserId = NavUserId,
                                                TradeMonth = TradeMonth,
                                                TradeDate = TradeDate,
                                                PayMode = PayMode,
                                                SeoTitle = "team",
                                            }).Entity;
                                            db.SaveChanges();
                                        }
                                        teamStat.TotalAmount += TradeAmount;
                                        teamStat.QueryCount += TradeCount;
                                    }
                                }
                                db.SaveChanges();

                                //商户交易额
                                MerchantAmountSummay merchantStat = db.MerchantAmountSummay.FirstOrDefault(m => m.MerchantId == MerchantId && m.TradeMonth == TradeMonth && m.TradeDate == TradeDate && m.PayMode == PayMode);
                                if (merchantStat == null)
                                {
                                    merchantStat = db.MerchantAmountSummay.Add(new MerchantAmountSummay()
                                    {
                                        MerchantId = MerchantId,
                                        TradeMonth = TradeMonth,
                                        TradeDate = TradeDate,
                                        PayMode = PayMode,
                                    }).Entity;
                                    db.SaveChanges();
                                }
                                merchantStat.TradeAmount += TradeAmount;
                                merchantStat.QueryCount += TradeCount;
                            }
                            OtherMySqlConn.op("update ConsumerOrders set QueryCount=1 where Id in (" + ids.TrimEnd(',') + ")");
                            function.WritePage("/ConsumerOrders/", "Id.txt", startId);
                        }
                        db.SaveChanges();
                    }
                    tran.Commit();
                }
                catch (Exception ex)
                {
                    tran.Rollback();
                    function.WriteLog(DateTime.Now.ToString() + "\n" + ex.ToString(), "统计昨天交易额V2异常");
                }
            }
            db.Dispose();
            function.WriteLog(DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss.fff") + "\n\n", "统计商户和创客交易额日志");
        }
    }
}